/* Copyright (C) 2011 Papavasileiou Dimitris                             
 *                                                                      
 * This program is free software: you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License as published by 
 * the Free Software Foundation, either version 3 of the License, or    
 * (at your option) any later version.                                  
 *                                                                      
 * This program is distributed in the hope that it will be useful,      
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        
 * GNU General Public License for more details.                         
 *                                                                      
 * You should have received a copy of the GNU General Public License    
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __STATE_H_
#define __STATE_H_

#include <stdio.h>

struct {
    double time, delta, latitude, longitude, speed;
    double course, hdop, vdop, pdop, altitude;
    char mode[2], northsouth, eastwest, fix, satellites;
    unsigned long date;
} gps;

struct {
    unsigned int id, elevation, azimuth, snr;
} satellites[12];

struct {
    char blink, subblink, running[3];
    unsigned char minutes[4], seconds[4];
    unsigned int ticks[4];
} timing;

struct {
    char running[3];
    double odometers[4];
} distance;

struct {
    unsigned int speed, delta;
    double voltage;
} engine;

struct {
    int tab, focus, brightness;
} display;

struct waypoint {
    char name[9];
    float longitude, latitude;
    char index;
} *waypoints;

struct {
    struct waypoint *waypoint;
    
    int cts, turn, editing;
    double distance;
    long digits;
} navigation;

struct {
    struct {
	double samples[120];
	int count;
    } graph;

    struct {
	double sum;
	int samples;
    } means[3];

    double peaks[6], resolutions[2];
    int mode, submode, zooms[2], hold[3];
} statistics;

struct {
    double ambient, coolant;
} temperature;

#endif
