/* Copyright (C) 2011 Papavasileiou Dimitris                             
 *                                                                      
 * This program is free software: you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License as published by 
 * the Free Software Foundation, either version 3 of the License, or    
 * (at your option) any later version.                                  
 *                                                                      
 * This program is distributed in the hope that it will be useful,      
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        
 * GNU General Public License for more details.                         
 *                                                                      
 * You should have received a copy of the GNU General Public License    
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <stdlib.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>

#include "state.h"

ISR(TIMER3_COMPA_vect)
{
    timing.blink = !timing.blink;
}

ISR(TIMER2_COMPA_vect)
{
    static int n;
    int i;

    for (i = 0 ; i < 4 ; i += 1) {
	if (i > 2 || timing.running[i]) {
	    timing.ticks[i] += 255;

	    if (timing.ticks[i] >= 15625) {
		timing.seconds[i] += 1;
		timing.ticks[i] -= 15625;
	    }

	    if (timing.seconds[i] >= 60) {
		timing.minutes[i] += 1;
		timing.seconds[i] = 0;
	    }
	}
    }

    /* This blinks about 5 times per second. */
    
    if (n < 12) {
    	n += 1;
    } else {
	timing.subblink = !timing.subblink;
    	n = 0;
    }
}
